;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>    ====             =====           ===        ===                      <<<<<<<<<<<<<<
;>>>>>>>>>  //      \\         //        \\        //    \\     //    \\      ||           <<<<<<<<<<<<<<
;>>>>>>>>> ||                 ||                  //      \\  //       \\     ||           <<<<<<<<<<<<<<
;>>>>>>>>>  \\====         ||                 //        \\//         \\    ||           <<<<<<<<<<<<<<
;>>>>>>>>>            \\      ||                ||                       ||   ||           <<<<<<<<<<<<<<
;>>>>>>>>>             ||     ||                ||                       ||   ||           <<<<<<<<<<<<<<
;>>>>>>>>>  \\====//        \\====//      ||                       ||   ======   <<<<<<<<<<<<<<
;>>>>>>>>>   Source     -    Code       -           Markup           - Language <<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Made by Frank Wiebeler <<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Copyright 2008 <<<<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


;-Fenster
;{
  Enumeration 
        #w_sprache
        #w_setup
        #w_Shortcut
  EndEnumeration
  
  Enumeration
        #g_sp_combo
        #g_sp_ok
        #g_sp_cancel
         
        #g_install
        #g_cancel
        #g_about
        
        #g_pfad
        #g_pfad_browse
        #g_pfad_text
        
        #g_welcometext
        #g_killonstart
        #g_scroll
        #g_sc_strg
        #g_sc_shift
        #g_sc_alt
        #g_sc_liste
        #g_sc_cancel
        #g_sc_ok
  EndEnumeration
;}


;-Plugin-Daten
;{
Enumeration 
      #pl_back
      #pl_anker
      #pl_forward
      #pl_scml
      #pl_all
EndEnumeration


Structure Plugin
      name.s
      exepfad.s
      iconpfad.s
      command.s
      shortcut.l

      tool_imgid.l

      txt_name.l
      
      chb_install.l
      
      chb_menu.l
      
      chb_toolbar.l
      txt_tool_icon.l
      btn_tool_icon.l
      img_tool_icon.l
      
      chb_shortcut.l
      btn_shortcut.l
      
      strg_command.l
      txt_command.l
EndStructure

Global Dim Plugin.Plugin(#pl_all-1)

;Texte fr die Gadgets 
Global pl_txt_install.s
Global pl_txt_menu.s
Global pl_txt_toolbar.s
Global pl_txt_shortcut.s
Global pl_txt_shortcut_konfig.s
Global pl_txt_command.s
Global txt_idekill.s
Global abouttext.s

Procedure Pluginoptions(id,name.s,exepfad.s,iconpfad.s,commando.s,y,Short,install=1,menu=1,toolbar=1,shortcut=1)
      With Plugin(id)
              \name=name
              \exepfad=exepfad
              \iconpfad=iconpfad
              \command=commando
              \shortcut=Short
              ContainerGadget(#PB_Any,0,y,1000,25,#PB_Container_Single)
              \txt_name=StringGadget(#PB_Any,10,3,120,20,name+":")
              \chb_install=CheckBoxGadget(#PB_Any,130,0,80,20,pl_txt_install)
              \chb_menu=CheckBoxGadget(#PB_Any,210,0,80,20,pl_txt_menu)
              
              ContainerGadget(#PB_Any,290,0,262,25,#PB_Container_Single)
              \chb_toolbar=CheckBoxGadget(#PB_Any,2,0,80,20,pl_txt_toolbar)
              \txt_tool_icon=StringGadget(#PB_Any,82,0,120,20,iconpfad.s,#PB_String_ReadOnly)
              \btn_tool_icon=ButtonGadget(#PB_Any,202,0,30,20,"...")
              \img_tool_icon=ImageGadget(#PB_Any,232,0,32,32,0)
              CloseGadgetList()
              If iconpfad
                    \tool_imgid=LoadImage(#PB_Any,iconpfad)
                    If \tool_imgid
                        SetGadgetState(\img_tool_icon,ImageID(\tool_imgid))
                    EndIf
              EndIf
              \chb_shortcut=CheckBoxGadget(#PB_Any,560,0,80,20,pl_txt_shortcut)
              \btn_shortcut=ButtonGadget(#PB_Any,660,0,100,20,pl_txt_shortcut_konfig)
              \txt_command=TextGadget(#PB_Any,760,0,80,20,pl_txt_command)
              \strg_command=StringGadget(#PB_Any,840,0,140,20,\command)
              SetGadgetState(\chb_install,install)
              SetGadgetState(\chb_menu,menu)
              SetGadgetState(\chb_toolbar,toolbar)
              SetGadgetState(\chb_shortcut,shortcut)
              
              If toolbar=0
                    DisableGadget(\btn_tool_icon,1)
                    DisableGadget(\txt_tool_icon,1)
              EndIf
              If shortcut=0
                    DisableGadget(\btn_shortcut,1)
              EndIf
              CloseGadgetList()
      EndWith
EndProcedure
;}


;-Shortcuts einstellen
Procedure KonfigShortcut(curcut.l,window)
Protected event,quit.l
    DisableWindow(window,1)
    If OpenWindow(#w_Shortcut,200,200,200,100,"Shortcuts")
            CreateGadgetList(WindowID(#w_Shortcut))
                    ButtonGadget(#g_sc_ok,0,80,100,20,"Anwenden")
                    ButtonGadget(#g_sc_cancel,100,80,100,20,"Abbrechen")
                    CheckBoxGadget(#g_sc_strg,0,0,100,20,"Strg / Ctrl")
                    CheckBoxGadget(#g_sc_shift,0,20,100,20,"Shift")
                    CheckBoxGadget(#g_sc_alt,0,40,100,20,"Alt")
                    ComboBoxGadget(#g_sc_liste,100,0,100,400)
                    For a=0 To 25
                          AddGadgetItem(#g_sc_liste,-1,Chr(a+65))
                    Next 
                    For a=0 To 9
                          AddGadgetItem(#g_sc_liste,-1,Str(a))
                    Next 
                    For a=1 To 24
                      AddGadgetItem(#g_sc_liste,-1,"F"+Str(a))
                    Next
                    For a=0 To 9
                      AddGadgetItem(#g_sc_liste,-1,"Numpad"+Str(a))
                    Next 
                    AddGadgetItem(#g_sc_liste,-1,"Space")
                    AddGadgetItem(#g_sc_liste,-1,"Arrow up")
                    AddGadgetItem(#g_sc_liste,-1,"Arrow down")
                    AddGadgetItem(#g_sc_liste,-1,"Arrow left")
                    AddGadgetItem(#g_sc_liste,-1,"Arrow right")
                    AddGadgetItem(#g_sc_liste,-1,"Page Up")
                    AddGadgetItem(#g_sc_liste,-1,"Page Down")
                    AddGadgetItem(#g_sc_liste,-1,"Finish")
                    AddGadgetItem(#g_sc_liste,-1,"Home/Pos1")
                    AddGadgetItem(#g_sc_liste,-1,"Enter")

                    AddGadgetItem(#g_sc_liste,-1,"+")
                    AddGadgetItem(#g_sc_liste,-1,"-")
                    AddGadgetItem(#g_sc_liste,-1,"Tab")
                    AddGadgetItem(#g_sc_liste,-1,"Delete")
                    AddGadgetItem(#g_sc_liste,-1,"Insert")
             holdcut=curcut
             If curcut&#PB_Shortcut_Control
                  SetGadgetState(#g_sc_strg,1)
                  curcut=curcut!#PB_Shortcut_Control
             EndIf
             If curcut&#PB_Shortcut_Alt
                  SetGadgetState(#g_sc_alt,1)
                  curcut=curcut!#PB_Shortcut_Alt
             EndIf
             If curcut&#PB_Shortcut_Shift
                  SetGadgetState(#g_sc_shift,1)
                  curcut=curcut!#PB_Shortcut_Shift
             EndIf

            Select curcut
                    Case #PB_Shortcut_A To #PB_Shortcut_Z
                            SetGadgetState(#g_sc_liste,curcut-#PB_Shortcut_A)
                    Case #PB_Shortcut_0 To  #PB_Shortcut_9
                            SetGadgetState(#g_sc_liste,curcut-#PB_Shortcut_0+26)
                    Case #PB_Shortcut_F1 To #PB_Shortcut_F24
                            SetGadgetState(#g_sc_liste,curcut-#PB_Shortcut_F1+36)
                    Case #PB_Shortcut_Pad0 To #PB_Shortcut_Pad9
                            SetGadgetState(#g_sc_liste,curcut-#PB_Shortcut_Pad0+60)
                    Case #PB_Shortcut_Space
                            SetGadgetState(#g_sc_liste,70)
                    Case #PB_Shortcut_Up
                            SetGadgetState(#g_sc_liste,71)
                    Case #PB_Shortcut_Down
                            SetGadgetState(#g_sc_liste,72)
                    Case #PB_Shortcut_Left
                            SetGadgetState(#g_sc_liste,73)
                    Case #PB_Shortcut_Right
                            SetGadgetState(#g_sc_liste,74)
                    Case #PB_Shortcut_Next
                            SetGadgetState(#g_sc_liste,75)
                    Case #PB_Shortcut_Prior
                            SetGadgetState(#g_sc_liste,76)
                    Case #PB_Shortcut_End
                            SetGadgetState(#g_sc_liste,77)
                    Case #PB_Shortcut_Home
                            SetGadgetState(#g_sc_liste,78)
                    Case #PB_Shortcut_Return
                            SetGadgetState(#g_sc_liste,79)
                    Case #PB_Shortcut_Add
                            SetGadgetState(#g_sc_liste,80)
                    Case #PB_Shortcut_Subtract
                            SetGadgetState(#g_sc_liste,81)
                    Case #PB_Shortcut_Tab 
                            SetGadgetState(#g_sc_liste,82)
                    Case #PB_Shortcut_Back
                            SetGadgetState(#g_sc_liste,83)
                    Case #PB_Shortcut_Insert
                            SetGadgetState(#g_sc_liste,84)
            
            EndSelect
            Repeat
                    event=WaitWindowEvent()
                    If event=#PB_Event_Gadget
                          Select EventGadget()
                                  Case #g_sc_cancel
                                        quit=-1
                                 Case #g_sc_ok
                                      quit=1                
                          EndSelect
                   ElseIf  event=#PB_Event_CloseWindow
                        quit=-1
                   EndIf
            Until quit<>0
            Select GetGadgetState(#g_sc_liste)
                    Case 0 To 25
                            newcut=#PB_Shortcut_A+GetGadgetState(#g_sc_liste)
                    Case 26 To 35
                            newcut=#PB_Shortcut_0+GetGadgetState(#g_sc_liste)-26
                    Case 36 To 59
                            newcut=#PB_Shortcut_F1+GetGadgetState(#g_sc_liste)-36
                    Case 60 To 69
                            newcut=#PB_Shortcut_Pad0+GetGadgetState(#g_sc_liste)-60
                    Case 70
                            newcut=#PB_Shortcut_Space
                    Case 71
                            newcut=#PB_Shortcut_Up
                    Case 72
                            newcut=#PB_Shortcut_Down
                    Case 73
                            newcut=#PB_Shortcut_Left
                    Case 74
                            newcut=#PB_Shortcut_Right
                    Case 75
                            newcut=#PB_Shortcut_Next
                    Case 76
                            newcut=#PB_Shortcut_Prior
                    Case 77
                            newcut=#PB_Shortcut_End
                    Case 78
                            newcut=#PB_Shortcut_Home
                    Case 79
                            newcut=#PB_Shortcut_Return
                    Case 80
                            newcut=#PB_Shortcut_Add
                    Case 81
                            newcut=#PB_Shortcut_Subtract
                    Case 82
                            newcut=#PB_Shortcut_Tab 
                    Case 83
                            newcut=#PB_Shortcut_Back
                    Case 84
                            newcut=#PB_Shortcut_Insert
            
            EndSelect
            If GetGadgetState(#g_sc_strg)=1
                  newcut=newcut|#PB_Shortcut_Control
             EndIf
            If GetGadgetState(#g_sc_alt)=1
                  newcut=newcut|#PB_Shortcut_All
             EndIf
            If GetGadgetState(#g_sc_shift)=1
                  newcut=newcut|#PB_Shortcut_Shift
             EndIf
            CloseWindow(#w_Shortcut)
    EndIf
    DisableWindow(window,0)
    SetActiveWindow(window)
    If quit=-1 Or quit=0
          newcut=holdcut
    EndIf
    ProcedureReturn newcut
EndProcedure
;-Sprachen-Dialog
;{
Global NewList Language.s()
Procedure Lang_Load()
                ExamineDirectory(1,"Sprachen","*.*")
                While NextDirectoryEntry(1)<>0
                      If DirectoryEntryType(1)=#PB_DirectoryEntry_File
                            AddElement(Language())
                            Language()=Left(DirectoryEntryName(1),Len(DirectoryEntryName(1))-4)
                      EndIf
                Wend  
                FinishDirectory(1)
EndProcedure

Procedure LanguageWindow()
Protected event,quit.l
    If OpenWindow(#w_sprache,100,100,200,45,"Choose your language")
          CreateGadgetList(WindowID(#w_sprache))
                ComboBoxGadget(#g_sp_combo,0,0,200,200)
                ForEach Language()
                      AddGadgetItem(#g_sp_combo,-1,Language())
                Next
                SetGadgetState(#g_sp_combo,0)
                ButtonGadget(#g_sp_cancel,0,25,100,20,"X")
                ButtonGadget(#g_sp_ok,100,25,100,20,">>")
         Repeat 
              event=WaitWindowEvent()
              If event=#PB_Event_Gadget
                    Select EventGadget()
                          Case #g_sp_cancel
                                quit=-1
                          Case #g_sp_ok
                                quit=GetGadgetState(#g_sp_combo)+1
                    EndSelect
              ElseIf event=#WM_CLOSE
                    quit=-1
              EndIf
         Until  quit<>0
         CloseWindow(#w_sprache)
   EndIf
         If quit>0
              ProcedureReturn quit-1
          Else 
            ProcedureReturn -1
          EndIf
EndProcedure

;}

Procedure  Install(pfad.s)
  pfad=pfad+"SCML\"
  CreateDirectory(pfad)
  CopyFile(GetEnvironmentVariable("APPDATA")+"\PureBasic\Tools.prefs",GetEnvironmentVariable("APPDATA")+"\PureBasic\Tools2.prefs")
  If OpenPreferences(GetEnvironmentVariable("APPDATA")+"\PureBasic\Tools.prefs");_RUN %APPDATA%/PureBasic/Tools.prefs
      PreferenceGroup("ToolsInfo")
      firsttool=ReadPreferenceLong("ToolCount",0)
      If GetGadgetState(#g_killonstart)=1
            CopyFile("Plugins\KillHis.exe",pfad+"KillHis.exe")
            PreferenceGroup("Tool_"+Str(firsttool))
            WritePreferenceString("Command",pfad+"KillHis.exe")
            WritePreferenceString("Arguments","")
            WritePreferenceString("WorkingDir",pfad)
            WritePreferenceString("MenuItemName","")
            WritePreferenceLong("Shortcut",0)
            WritePreferenceString("ConfigLine","")
            WritePreferenceLong("Trigger",1)
            WritePreferenceLong("Flags",3);Jeweils auf Ende des Tools warten
            WritePreferenceLong("ReloadSource",0)
            WritePreferenceLong("HideEditor",0)
            WritePreferenceLong("HideFromMenu",1)
            WritePreferenceLong("SourceSpecific",0)
            WritePreferenceLong("Deactivate",0)
            firsttool=firsttool+1
      EndIf
      For a=0 To #pl_all-1
              If GetGadgetState(Plugin(a)\chb_install)=1
                                        CopyFile("Plugins\"+Plugin(a)\exepfad,pfad+Plugin(a)\exepfad)
                                        Plugin(a)\exepfad="SCML\"+Plugin(a)\exepfad
                                        PreferenceGroup("Tool_"+Str(firsttool))
                                        WritePreferenceString("Command",pfad+Plugin(a)\exepfad)
                                        WritePreferenceString("Arguments",Plugin(a)\command)
                                        WritePreferenceString("WorkingDir",pfad)
                                        WritePreferenceString("MenuItemName",Plugin(a)\name)
                                        WritePreferenceLong("Shortcut",Plugin(a)\shortcut*GetGadgetState(Plugin(a)\chb_shortcut))
                                        WritePreferenceString("ConfigLine","")
                                        WritePreferenceLong("Trigger",0)
                                        WritePreferenceLong("Flags",1);Jeweils auf Ende des Tools warten
                                        WritePreferenceLong("ReloadSource",0)
                                        WritePreferenceLong("HideEditor",0)
                                        WritePreferenceLong("HideFromMenu",GetGadgetState(Plugin(a)\chb_menu)!1)
                                        WritePreferenceLong("SourceSpecific",0)
                                        WritePreferenceLong("Deactivate",0)
                                        firsttool=firsttool+1
              EndIf
      Next
      PreferenceGroup("ToolsInfo")
      WritePreferenceLong("ToolCount",firsttool)
      ClosePreferences()
      CopyFile(GetEnvironmentVariable("APPDATA")+"\PureBasic\PureBasic.prefs",GetEnvironmentVariable("APPDATA")+"\PureBasic\PureBasic1.prefs")
      If OpenPreferences(GetEnvironmentVariable("APPDATA")+"\PureBasic\PureBasic.prefs")
          PreferenceGroup("Toolbar")
          firstbar=ReadPreferenceLong("ItemCount",0)+1
          For a=0 To #pl_scml-1
                  If GetGadgetState(Plugin(a)\chb_install)=1 And GetGadgetState(Plugin(a)\chb_toolbar)=1
                        lines=1
                        Break
                  EndIf
          Next
          If lines=1
                  WritePreferenceString("Icon_"+Str(firstbar),"Separator")
                  WritePreferenceString("Action_"+Str(firstbar),"")
                  firstbar=firstbar+1
          EndIf
          For a=0 To #pl_scml-1
                  If GetGadgetState(Plugin(a)\chb_install)=1 And GetGadgetState(Plugin(a)\chb_toolbar)=1
                                            CopyFile(Plugin(a)\iconpfad,pfad+GetFilePart(Plugin(a)\iconpfad))
                                            Plugin(a)\iconpfad=pfad+GetFilePart(Plugin(a)\iconpfad)
                                            WritePreferenceString("Icon_"+Str(firstbar),"External:"+Plugin(a)\iconpfad)
                                            WritePreferenceString("Action_"+Str(firstbar),"Tool:"+Plugin(a)\name)
                                            firstbar=firstbar+1
                  EndIf
          Next
          If GetGadgetState(Plugin(#pl_scml)\chb_install)=1 And GetGadgetState(Plugin(#pl_scml)\chb_toolbar)=1
                  CopyFile(Plugin(#pl_scml)\iconpfad,pfad+GetFilePart(Plugin(#pl_scml)\iconpfad))
                  Plugin(#pl_scml)\iconpfad=pfad+GetFilePart(Plugin(#pl_scml)\iconpfad)
                  WritePreferenceString("Icon_"+Str(firstbar),"Separator")
                  WritePreferenceString("Action_"+Str(firstbar),"")
                  firstbar=firstbar+1
                  WritePreferenceString("Icon_"+Str(firstbar),"External:"+Plugin(#pl_scml)\iconpfad)
                  WritePreferenceString("Action_"+Str(firstbar),"Tool:"+Plugin(#pl_scml)\name)
                  firstbar=firstbar+1
          EndIf
          PreferenceGroup("Toolbar")
          WritePreferenceLong("ItemCount",firstbar)
          ClosePreferences()
      EndIf
   EndIf
EndProcedure

Procedure InstallDialog(sprache.l)
Protected event,quit.l,pfad.s
      If OpenPreferences(GetEnvironmentVariable("APPDATA")+"\PureBasic\PureBasic.prefs");_RUN %APPDATA%/PureBasic/PureBasic.prefs
          PreferenceGroup("Global")
          anfpfad.s=ReadPreferenceString("LanguageFile","")
          pfad.s=""
          For a=1 To CountString(anfpfad,"\")-3
              pfad=pfad+StringField(anfpfad,a,"\")+"\"
          Next
          ClosePreferences()
      EndIf    
      SelectElement(Language(),sprache)
      If ReadFile(1,"Sprachen\"+Language()+".txt")
          If OpenWindow(#w_setup,0,100,860,280,ReadString(1))
              CreateGadgetList(WindowID(#w_setup))
                   TextGadget(#g_welcometext,0,0,760,40,ReadString(1)+Chr(13)+Chr(10)+ReadString(1))
                   pl_txt_install=ReadString(1)
                   pl_txt_menu=ReadString(1)
                   pl_txt_toolbar=ReadString(1)
                   pl_txt_shortcut=ReadString(1)
                   pl_txt_shortcut_konfig=ReadString(1)
                   pl_txt_command=ReadString(1)
                   txt_idekill=ReadString(1)
                   ScrollAreaGadget(#g_scroll,0,40,WindowWidth(#w_setup),212,1000,190,1)
                   TextGadget(#g_pfad_text,0,0,100,20,ReadString(1))
                   StringGadget(#g_pfad,100,0,400,20,pfad)
                   ButtonGadget(#g_pfad_browse,500,0,40,20,"....")
                   CheckBoxGadget(#g_killonstart,0,20,300,20,ReadString(1))
                   SetGadgetState(#g_killonstart,1)
                   Pluginoptions(#pl_anker,ReadString(1),"History_Add.exe","Icons/Anker.ico",Chr(34)+"%FILE"+Chr(34)+Chr(34)+"%CURSOR"+Chr(34),50,131125)
                   Pluginoptions(#pl_back,ReadString(1),"History_Zurueck.exe","Icons/Back.ico",Chr(34)+"%FILE"+Chr(34)+Chr(34)+"%CURSOR"+Chr(34)+" "+Chr(34)+"BACK"+Chr(34),90,131124)
                   Pluginoptions(#pl_forward,ReadString(1),"History_Zurueck.exe","Icons/Forward.ico",Chr(34)+"%FILE"+Chr(34)+Chr(34)+"%CURSOR"+Chr(34)+" "+Chr(34)+"FORWARD"+Chr(34),120,131126)
                   Pluginoptions(#pl_scml,ReadString(1),"SCML.exe","Icons/SCML.ico",Chr(34)+"%FILE"+Chr(34)+Chr(34)+"%CURSOR"+Chr(34),150,131127)                   
                   CloseGadgetList()
                   ButtonGadget(#g_install,20,250,260,20,ReadString(1))
                   ButtonGadget(#g_cancel,300,250,260,20,ReadString(1))
                   ButtonGadget(#g_about,580,250,200,20,ReadString(1))
                   abouttext=ReplaceString(ReadString(1),"\n",Chr(13)+Chr(10))
                   CloseFile(1)
                   Repeat 
                        event=WaitWindowEvent()
                        If event=#WM_CLOSE
                              quit=-1
                        ElseIf event=#PB_Event_Gadget
                              Select EventGadget()
                                    Case #g_cancel
                                          quit=-1
                                    Case #g_install
                                          MessageRequester("Info",txt_idekill)
                                          Install(pfad)
                                          quit=1
                                    Case #g_about
                                         MessageRequester("About",abouttext)
                                    Case #g_pfad
                                          pfad=GetGadgetText(#g_pfad)
                                    Case #g_pfad_browse
                                          neu.s=PathRequester("Browse Path",pfad)
                                          If neu
                                                pfad=neu
                                                SetGadgetText(#g_pfad,pfad)
                                          EndIf
                                    Default
                                            For a=0 To #pl_all-1
                                                Select EventGadget()
                                                        Case Plugin(a)\chb_toolbar
                                                              DisableGadget(Plugin(a)\txt_tool_icon,GetGadgetState(Plugin(a)\chb_toolbar)!1)
                                                              DisableGadget(Plugin(a)\btn_tool_icon,GetGadgetState(Plugin(a)\chb_toolbar)!1)
                                                              Break
                                                        Case Plugin(a)\chb_shortcut
                                                              DisableGadget(Plugin(a)\btn_shortcut,GetGadgetState(Plugin(a)\chb_shortcut)!1)
                                                              Break
                                                        Case Plugin(a)\btn_tool_icon
                                                              name.s=OpenFileRequester("Search an Icon",Plugin(a)\Iconpfad,"Iconfiles|*.ico*",0)
                                                              If name
                                                                  If IsImage(Plugin(a)\tool_imgID)
                                                                        FreeImage(Plugin(a)\tool_imgID)
                                                                  EndIf
                                                                  Plugin(a)\tool_imgID=LoadImage(#PB_Any,name)
                                                                  If Plugin(a)\tool_imgID
                                                                        Plugin(a)\Iconpfad=name
                                                                        SetGadgetText(Plugin(a)\txt_tool_icon,name)
                                                                        SetGadgetState(Plugin(a)\img_tool_icon,ImageID(Plugin(a)\tool_imgID))
                                                                  EndIf
                                                              EndIf
                                                        Case Plugin(a)\chb_install
                                                                status=GetGadgetState(Plugin(a)\chb_install)!1
                                                                *pointer.Long=@Plugin(a)\chb_install+4
                                                                For b=0 To 6
                                                                       DisableGadget(*pointer\l,status)
                                                                       *pointer+4
                                                                Next 
                                                                DisableGadget(Plugin(a)\txt_tool_icon,GetGadgetState(Plugin(a)\chb_toolbar)!1)
                                                                DisableGadget(Plugin(a)\btn_tool_icon,GetGadgetState(Plugin(a)\chb_toolbar)!1)
                                                                DisableGadget(Plugin(a)\btn_shortcut,GetGadgetState(Plugin(a)\chb_shortcut)!1)
                                                                Break
                                                        Case Plugin(a)\btn_shortcut
                                                                Plugin(a)\shortcut=KonfigShortCut(Plugin(a)\shortcut,#w_setup)
                                                                Break
                                                        Case Plugin(a)\strg_command
                                                                Plugin(a)\command=GetGadgetText(Plugin(a)\strg_command)
                                                EndSelect
                                          Next
                              EndSelect
                        EndIf
                   Until  quit<>0
          EndIf
      EndIf
EndProcedure


Lang_Load()
sprache=LanguageWindow()
If sprache <>-1
    InstallDialog(sprache)
EndIf
; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 436
; FirstLine = 373
; Folding = ---
; EnableAsm
; EnableXP
; UseIcon = Icons\Installer.ICO
; Executable = SCML_Final\Installer.exe