;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>    ====             =====           ===        ===                      <<<<<<<<<<<<<<
;>>>>>>>>>  //      \\         //        \\        //    \\     //    \\      ||           <<<<<<<<<<<<<<
;>>>>>>>>> ||                 ||                  //      \\  //       \\     ||           <<<<<<<<<<<<<<
;>>>>>>>>>  \\====         ||                 //        \\//         \\    ||           <<<<<<<<<<<<<<
;>>>>>>>>>            \\      ||                ||                       ||   ||           <<<<<<<<<<<<<<
;>>>>>>>>>             ||     ||                ||                       ||   ||           <<<<<<<<<<<<<<
;>>>>>>>>>  \\====//        \\====//      ||                       ||   ======   <<<<<<<<<<<<<<
;>>>>>>>>>   Source     -    Code       -           Markup           - Language <<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Made by Frank Wiebeler <<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Copyright 2008 <<<<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;->FUNCTIONS For the Plugins

Declare ErrorMessage(text.s)
#startstring=";_"

#his_back="History_Back.txt"
#his_forward="History_Forward.txt"

#Class_Panel="systabcontrol32"
#Class_Scintilla="scintilla"
#Class_Protokoll="listbox"

Structure Function
       name.s
       code.s
EndStructure

Global mainwindow.l;IDE-Hauptfenster
Global Scintilla.l;aktuelles Scintilla-Gadget
Global NewList Scintillas.l();Liste aller Scintillas
Global filelist.s;Liste der geffneten Dateien
Global Tablist.l;Panelgadget
Global ProtokollView.l;ErrorListe

Global NewList Gadgets.l()


Procedure SetActiveTab(ggtid,item,window=0)
      If window=0
            window=GetParent_(ggtid)
      EndIf
      SendMessage_(ggtid,#TCM_SETCURSEL,item,0)
      SendMessage_(window,#WM_COMMAND,#TCM_SETCURSEL,ggtid)
EndProcedure

Procedure GetActiveTab(ggtid)
    ProcedureReturn SendMessage_(ggtid,#TCM_GETCURSEL,0,0)
EndProcedure

Procedure AddListViewItem(ggtid,item,text.s,window=0)
Protected  var.LV_ITEM
      If window=0
            window=GetParent_(ggtid)
      EndIf
      SendMessage_(ggtid,#LB_INSERTSTRING,item,@text)
EndProcedure

Procedure.s GetScintillaText(adr.l)
Protected window.l
Protected prozess.l,prochandle.l,VirtualMemory
Protected laenge.l,text.s
      window.l=GetParent_(adr)
      If window=0
            ProcedureReturn ""
      EndIf
      GetWindowThreadProcessId_(window,@prozess)
      prochandle=OpenProcess_(#PROCESS_ALL_ACCESS,#False,prozess)
      If prochandle=0
              ProcedureReturn ""
      EndIf
      laenge=SendMessage_(adr,#SCI_GETTEXTLENGTH,0,0)
      VirtualMemory=VirtualAllocEx_(prochandle,0,laenge+1,#MEM_COMMIT,#PAGE_READWRITE)
      If VirtualMemory=0
            ProcedureReturn ""
      EndIf
      text=Space(laenge+1)
      SendMessage_(adr,#SCI_GETTEXT,laenge,VirtualMemory)
      ReadProcessMemory_(prochandle,VirtualMemory,@text,laenge,0)
      VirtualFreeEx_(prochandle,VirtualMemory,0,#MEM_RELEASE)
      CloseHandle_(procid)
      ProcedureReturn text
EndProcedure

Procedure AddGadget(gadget.l,wert)
      AddElement(Gadgets())
            Gadgets()=gadget
            ProcedureReturn gadget
EndProcedure

Procedure GetGadgets(window.l);Sucht Panel,Scintillas und Errorliste
Protected Ort.Rect,Ort2.Rect
            EnumChildWindows_(window,@AddGadget(),1)
            CallDebugger
            ;Messagerequester("Gefundene Gadgets:",Str(CountList(Gadgets())))
            ;Zuerst die Scintillagadgets suchen
            ForEach Gadgets()
                  string.s=Space(500)
                  GetClassName_(Gadgets(),string,500)
                  Select LCase(string)
                        Case #Class_Scintilla
                                  AddElement(Scintillas())
                                  Scintillas()=Gadgets()
                  EndSelect
            Next
            ;X-Koordinate der Scintillas ergibt auch X-Koordinate von Panel und Listview
            FirstElement(Scintillas())
            GetWindowRect_(Scintillas(),@Ort)
            ForEach Gadgets()
                  string.s=Space(500)
                  GetClassName_(Gadgets(),string,500)
                  Select LCase(string)
                        Case #Class_Panel
                            If Tablist=0
                                GetWindowRect_(Gadgets(),@Ort2)
                                If Ort\left=Ort2\left
                                      Tablist=Gadgets()
                                EndIf
                            EndIf
                        Case #Class_Protokoll
                            If ProtokollView=0
                                GetWindowRect_(Gadgets(),@Ort2)
                                If Ort\left=Ort2\left
                                      ProtokollView=Gadgets()
                                EndIf
                            EndIf
                     EndSelect
            Next
            string.s="Tablist: "+Str(Tablist)+Chr(13)
            string.s=string+"Protokoll:"+Str(ProtokollView)
            ;Messagerequester("Fensterdaten:",string)
            If CountList(Scintillas())>0 And Tablist<>0 And ProtokollView<>0
                    ProcedureReturn 1
            EndIf
EndProcedure

Procedure GetEditorVars();Wichtige Variablen auslesen
            mainwindow.l=Val(GetEnvironmentVariable("PB_TOOL_MainWindow"))
            scintilla.l=Val(GetEnvironmentVariable("PB_TOOL_Scintilla"))
            ;Messagerequester("Fensteradressen","Hauptfenster"+Str(mainwindow)+Chr(13)+"Scintilla"+Str(Scintilla))
EndProcedure

Procedure SetScintillaCursor(ggtid,line,letter);Setzt den Cursor bisher nur auf die richtige zeile. Letter bringt noch nix
            SendMessage_(ggtid,#SCI_GOTOLINE,line-1,0)
            
EndProcedure

Procedure IsFileLoaded(file.s);Gibt den Tab wieder, der die gesuchte Datei beinhaltet (oder -1, wenn nicht geladen)
            file=UCase(File)
            filelist.s=GetEnvironmentVariable("PB_TOOL_FileList")
            ;MessageRequester("Geladene Dateien",ReplaceString(filelist,Chr(10),Chr(13)))
            For a=0 To CountString(filelist,Chr(10))
                  ;MessageRequester("Handvergleich:",file+Chr(13)+UCase(StringField(filelist,a+1,Chr(10)))+Chr(13))
                  If file=UCase(StringField(filelist,a+1,Chr(10)))
                        ;MessageRequester("Gefundener Tab:",Str(a))
                        ProcedureReturn a
                  EndIf
            Next
            ProcedureReturn -1
EndProcedure

Procedure MakeOneInstance();Sicher stellen, dass nur eine Instanz gestartet wird
        If OpenPreferences(GetEnvironmentVariable("APPDATA")+"PureBasic/Purebasic.prefs")
                oldway=ReadPreferenceLong("RunOnce",1)
                WritePreferenceLong("RunOnce",0)
                ClosePreferences()
        EndIf
        ProcedureReturn oldway
EndProcedure

Procedure ResetInstancePrefs(type);Altes verhalten bzgl. Instanz wieder herstellen
        If OpenPreferences(GetEnvironmentVariable("APPDATA")+"PureBasic/Purebasic.prefs")
                WritePreferenceLong("RunOnce",type)
                ClosePreferences()
        EndIf
EndProcedure

Procedure SelectFileTab(filename.s);Korrekten Tab im Panel selektieren und dadurch das richtige Scintilla-Gadget aktivieren
    id=IsFileLoaded(filename)
    If id=-1;Ist die Datei nicht geladen, einfach nachladen
        type=MakeOneInstance()
        If FileSize(Filename)<1
              ErrorMessage("Datei nicht gefunden")
        EndIf
        RunProgram(Filename)
        ResetInstancePrefs(type)
        filelist=filelist+Chr(10)+Filename        
        id=CountString(filelist,Chr(10))+1
    EndIf
    GetEditorVars()
    If GetGadgets(mainwindow)
        ForEach Scintillas();Correctes ScintillaGadget finden
              If IsWindowVisible_(Scintillas())=1
                    scintilla=Scintillas()
                    Break 
              EndIf
        Next 
        If id<>GetActiveTab(Tablist);Falls das Aktuelle Tab nicht das ist, wo hingesprungen werden soll, muss dieses erst aktiviert werden
              SetActiveWindow_(mainwindow)
              SetActiveTab(Tablist,id,mainwindow)
              ;While Val(GetEnvironmentVariable("PB_TOOL_Scintilla"))=scintilla: Delay(10):Wend ;Warten, bis es verarbeitet wurde
              found=0
              While IsWindowVisible_(Scintilla)=1 :Delay(1):Wend;Warten, bis der aktuelle Tab ausgeblendet wurde
                  
              While found=0
                    ForEach Scintillas()
                            If IsWindowVisible_(Scintillas())
                                  Scintilla=Scintillas()
                                  Break 2
                            EndIf
                    Next
              Wend  
              SetEnvironmentVariable("PB_TOOL_Scintilla",Str(scintilla))
         EndIf
    EndIf
EndProcedure


Procedure WarnMessage(title.s) ;Kein Abbruch des Programms
        GetEditorVars()
        GetGadgets(mainwindow)
        entry.s="["+Str(Hour(Date()))+":"+Str(Minute(Date()))+":"+Str(Second(Date()))+"] [PLUGIN] "+title
        ;Messagerequester("Klasse der Box unten:",Str(ProtokollView)+"  "+string)
        AddListViewItem(ProtokollView,-1,entry)
EndProcedure

Procedure ErrorMessage(title.s)
      WarnMessage(title)
      End 
EndProcedure;_?test

Procedure FindStringOutSideString(string.s,stringtofind.s,startpos.l=1)
          pos=FindString(string,stringtofind,startpos)
          While pos<>0 And CountString(Left(string,pos),Chr(34))%2=1
                  pos=FindString(string,stringtofind,pos+1)
          Wend  
          ProcedureReturn pos
EndProcedure

Procedure CallSourceLine(source.s,line.l)

EndProcedure

Procedure GotoSourceAdress(Source.s,line.l,letter.l);_?pos
        SelectFileTab(Source)
        SetScintillaCursor(scintilla,line,letter)
EndProcedure

Procedure GotoSourcePointer(Source.s,Pointer.s)
Protected id.l,found.l=0
Protected text.s,pos.l
Protected line.s
Protected zeile.l=1
        SelectFileTab(Source)
        If Left(pointer,1)<>"?"
                pointer="?"+pointer
        EndIf
        filetext.s=GetScintillaText(Scintilla)
        filetext=RemoveString(filetext," ")
        menge=CountString(filetext,Chr(13))+1
        adr=0
        While found=0
                adr=FindString(filetext,pointer,adr+1)
                If adr=0;Der Pointer ist nicht bekannt
                       ErrorMessage("Pointer not found")
                EndIf
                pos2=0
                pos=0
                While pos<adr
                      pos=FindString(filetext,Chr(13),pos+1)
                      pos2=pos2+1
                Wend 
                line=StringField(filetext,pos2,Chr(13))
                line=Mid(line,FindString(line,#startstring,1)+2)
                line=RemoveString(line," ")
                If Len(line)=FindString(line,pointer,1)+Len(POINTer) Or Left(line,Len(pointer))=pointer Or FindString(line,"|"+pointer+"|",1)
                      found=1
                      zeile=pos2
                      Break
                 EndIf
        Wend 
        WarnMessage("LINE: "+Str(zeile))
        SetScintillaCursor(scintilla,zeile+1,1)
EndProcedure

Procedure AddHisEntry(file.s,curpos.s)
    If   OpenFile(1,#his_back)
          FileSeek(1,Lof(1))
                WriteStringN(1,file+"|"+curpos)
          CloseFile(1) 
    Else
        ErrorMessage("Historyfile not found")
    EndIf
    ;Alte History-Vor-Datei killen
    CreateFile(1,#his_forward)
    CloseFile(1)
EndProcedure


;WarnMessage("Dies ist nur son test, wa?")
; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 223
; FirstLine = 220
; Folding = ----
; EnableAsm
; Executable = D:\Programme\PureBasic4.20\PBCML-Plugin\Warnung.exe